int photocellPin = 0;    
int photocellReading;     
int LEDpin = 5;        
int Noled=0;       
int Yesled=0;
byte statusLed    = 13;
byte sensorInterrupt = 0;  
byte sensorPin       = 2;

float calibrationFactor = 4.5;

volatile byte pulseCount;  

float flowRate;
unsigned int flowMilliLitres;
unsigned long Maxflow=0;

unsigned long oldTime;

void serialFlush(){
  while(Serial.available() > 0) {
    char t = Serial.read();
  }
} 


void setup(void) {

  Serial.begin(9600);   
  pinMode(LEDpin, OUTPUT);
  photocellReading = analogRead(photocellPin);
  Noled=photocellReading;
  pinMode(statusLed, OUTPUT);
  digitalWrite(statusLed, HIGH);  
  for (int i=0; i <= 100; i++)                                    // For petlja za računanje prosjeka mjerenja bez upaljene ledice
  {
    photocellReading = analogRead(photocellPin);
    Noled=(Noled+photocellReading)/2;
  }

  digitalWrite(LEDpin, HIGH);   
  photocellReading = analogRead(photocellPin);
  Yesled=photocellReading;
  for (int i=0; i <= 100; i++)                                     // For petlja za računanje prosjeka mjerenja sa upaljenom ledicom
  {
    photocellReading = analogRead(photocellPin);
    Yesled=(Yesled+photocellReading)/2;
 
  }
 
  pinMode(sensorPin, INPUT);
  digitalWrite(sensorPin, HIGH);
  pulseCount        = 0;
  flowRate          = 0.0;
  flowMilliLitres   = 0;
  oldTime           = 0;
  attachInterrupt(sensorInterrupt, pulseCounter, FALLING);
  pulseCount=0;
  do{                                                                // Čekanje da počne protok
    flowRate = ((1000.0 / (millis() - oldTime)) * pulseCount) / calibrationFactor;
  }while(flowRate==0);
  for (int i=0; i <= 1000; i++)
  {
    delay(5);
    if((millis() - oldTime) > 1000)
    {
    detachInterrupt(sensorInterrupt);
    flowRate = ((1000.0 / (millis() - oldTime)) * pulseCount) / calibrationFactor;
    oldTime = millis();
    flowMilliLitres = (flowRate / 60) * 1000;
    if (Maxflow<flowMilliLitres)
    Maxflow=flowMilliLitres;

     attachInterrupt(sensorInterrupt, pulseCounter, FALLING);
    }
    
  }
  
  if(Yesled>(Noled+100))
  if(Maxflow>50)                                                               // Ukoliko oboje radi pošalji mail
  { 
      Serial.println("ATE1");
      delay(1000);
      Serial.println("AT+CWMODE=3");
      delay(1000);
      Serial.println("AT+CWQAP");
      delay(1000);
      Serial.println("AT+RST");
      delay(5000);
      do {
              serialFlush();
              Serial.println("AT+CWJAP=\"\",\"\"");                             // Između apostrofa upisati Ime i Password WIFI mreže, primjer AT+CWJAP="Ime123","Sifra123"
              delay(7000);
      }while (Serial.find("OK"));
      Serial.println("AT+CIPMUX=1");
      delay(2000);
      Serial.println("AT+CIPSERVER=1,80");
      delay(2000);
      digitalWrite(statusLed, LOW);
      Serial.println("AT+CIPSTART=4,\"TCP\",\"mail.smtp2go.com\",2525");
      delay(5000);
      Serial.println("AT+CIPSEND=4,20");
      delay(1000);
      Serial.println("EHLO 192.168.1.123");
      delay(4000);
      Serial.println("AT+CIPSEND=4,12");
      delay(1000);
      Serial.println("AUTH LOGIN");
      delay(3000);
      Serial.println("AT+CIPSEND=4,34");
      delay(1000);
      Serial.println("");                                       //base64 encoded username; https://www.base64encode.org/
      delay(3000);
      Serial.println("AT+CIPSEND=4,14");
      delay(1000);
      Serial.println("");                                       //base64 encoded password
      delay(3000);
      Serial.println("AT+CIPSEND=4,31");
      delay(1000);
      Serial.println("MAIL FROM:<primjer@gmail.com>");                           // email s kojega se šalje poruka
      delay(3000);
      Serial.println("AT+CIPSEND=4,29");
      delay(1000);
      Serial.println("RCPT To:<primjer@gmail.com>");                             //email na koji želimo primiti poruku
      delay(5000);
      Serial.println("AT+CIPSEND=4,6");
      delay(1000);
      Serial.println("DATA");
      delay(3000);
      Serial.println("AT+CIPSEND=4,16");
      delay(1000);
      Serial.println("Provjera: Radi");                             //sadržaj koji želimo poslati
      delay(2000);
      Serial.println("AT+CIPSEND=4,3");
      delay(1000);
      Serial.println('.');
      delay(10000);
      Serial.println("AT+CIPSEND=4,6");
      delay(1000);
      Serial.println("QUIT");
      delay(2000);
      digitalWrite(statusLed, LOW);
      digitalWrite(LEDpin, LOW);
  }
}
 
void loop(void) {
}
void pulseCounter()
{
  // Increment the pulse counter
  pulseCount++;
}

